<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Alexander Langer <alex@big.endian.de>
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'Extended Calendar' for the 'calendar' extension.
 *
 * @author	Alexander Langer <alex@big.endian.de>
 */

require_once(PATH_tslib."class.tslib_pibase.php");

/* This corrensponds to the values you can set in the backend */
define("CALENDAR_VIEW_MONTH", 0);
define("CALENDAR_VIEW_WEEK", 1);
define("CALENDAR_VIEW_DAY", 2);
define("CALENDAR_VIEW_UPCOMING", 3);
define("CALENDAR_VIEW_EVENT", 4);


function sort_events_by_starttime($a, $b) {
	if ($a['start_date'] + $a['start_time'] < $b['start_date'] + $b['start_time'])
		return false;
	else
		return true;
}

class tx_calendar_pi1 extends tslib_pibase {
	var $prefixId = "tx_calendar_pi1";		// Same as class name
	var $scriptRelPath = "pi1/class.tx_calendar_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "calendar";	// The extension key.
	var $dbTable = "tx_calendar_item";
	var $allowCaching = true;

	function strtotime($content, $conf) {
		return strtotime($conf['strtotime'], $content);
	}
	
	function initdefaults($content, $conf) {

		$this->conf=$conf;

		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_initPIflexForm(); // Init FlexForm configuration for plugin

		$this->internal["currentTable"] = $this->dbTable;

                // pid_list is the pid/list of pids from where to fetch the news items.
                $pid_list = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'pages');
                $pid_list = $pid_list ? implode(t3lib_div::intExplode(',', $pid_list), ',') : $GLOBALS['TSFE']->id;

                $recursive = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'recursive', 'sDEF');
                // extend the pid_list by recursive levels
                $this->pid_list = $this->pi_getPidList($pid_list,$recursive);

		$this->init_cats();
	}

	function init_cats() {
		$this->loadCategories();
	}

	function main($content,$conf)	{
		$conf = $this->toplevelConfig($conf);
		$this->initdefaults($content, $conf);
		$content .= $this->pi_getEditPanel();

		switch ($this->getCurrentView()) {
			case CALENDAR_VIEW_WEEK:
				$content .= $this->displayWeekFirst();
				break;
			case CALENDAR_VIEW_DAY:
				$content .= $this->displayDayFirst();
				break;
			case CALENDAR_VIEW_EVENT:
				$content .= $this->displayEventFirst($this->pi_getRecord($this->dbTable, intval($this->piVars['f1'])), $conf);
				break;
			case CALENDAR_VIEW_UPCOMING:
				$content .= $this->displayUpcomingFirst();
				break;
			case CALENDAR_VIEW_MONTH:
			default:
				$content .= $this->displayMonthFirst();
				break;
		}
		return $this->pi_wrapInBaseClass($content);
	}

	function toplevelConfig($conf) {
                $TSprefix = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'typoscript_prefix');
		if ($TSprefix != "") {
			$conf = $conf[$TSprefix.'.'];
		}
		return $conf;
	}


	/**
	 * Loading the categories into an internal array, $this->categories
	 */
	function loadCategories() {
		$query = $this->pi_categoriesUsed("tx_calendar_cat");
		$res = mysql(TYPO3_db, $query);
		if (mysql_errno()) {
			die(mysql_error());
		}

                $catmode = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'categoryMode', 's_category');
                $ffcats = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'categorySelection', 's_category');
		$ffcatsarray = split(",", $ffcats);

		if ($catmode == 0) {
		 	$this->categories[0] = array(
		 		'uid'	=>	0,
		 		'title'	=>	'[no category]',
		 	);
		}

		while ($row = mysql_fetch_assoc($res)) {
			switch ($catmode) {
				case 0:
					// add all
					$this->categories[$row["uid"]] = $row;
					break;
				case 1:
					if (in_array($row['uid'], $ffcatsarray)) {
						$this->categories[$row["uid"]] = $row;
					}
					break;
				case 2:
					print "jo";
					if (!in_array($row['uid'], $ffcatsarray))
						$this->categories[$row["uid"]] = $row;
					break;
			}
		}
	}

	/**
	 * (Maybe bad name for this function) construct SQL-query for
	 * organizers
	 */
	function pi_organizersUsed($cat_table) {
		// XXX should be modified to return only organizers that are really in use.  
		$pidList = $this->getPidlist();
		$query = "SELECT ".$cat_table.".* "."\n"."FROM $cat_table WHERE $cat_table.pid IN ($pidList)".$this->cObj->enableFields($cat_table)."\n";
		return $query;
	}
	/**
	 * (Maybe bad name for this function) construct SQL-query for
	 * categories.
	 */
	function pi_categoriesUsed($cat_table) {
		// XXX should be modified to return only categories that are really in use.  
		$pidList = $this->getPidlist();
		$query = "SELECT ".$cat_table.".* "."\n"."FROM $cat_table WHERE $cat_table.pid IN ($pidList)".$this->cObj->enableFields($cat_table)."\n";
		return $query;
	}


	function setFlexValues(&$ar) {
		// feed extra values into content object
		$ar['PAGE_EVENT']	= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'event_page');
		$ar['PAGE_DAY']		= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'day_page');
		$ar['PAGE_WEEK']	= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'week_page');
		$ar['PAGE_MONTH']	= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'month_page');
		$ar['PAGE_YEAR']	= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'year_page');
	}

	function displayEventFirst($row, $conf) {
		$template = $this->loadTemplate();
		// This sets the title of the page for use in indexed search results:
		if ($row["title"])
			$GLOBALS["TSFE"]->indexedDocTitle = $row["title"];

		return $this->displayEvent($row, $conf['displayEvent.'], $template);
	}

	function displayEvent($row, $conf, $template) {
		$this->setFlexValues($row);
		$row['TEMPLATE_EVENT'] = $template;
		$row['event_start'] = $row['start_date'] + $row['start_time'];
		$row['event_end'] = $row['end_date'] + $row['end_time'];
		$eventobj = t3lib_div::makeInstance('tslib_cObj');   // Create new tslib_cObj for our use
		$eventobj->start($row);
		$addevent = $eventobj->cObjGetSingle($conf['event'], $conf['event.']);
		return $addevent;
	}

	function makeDayRow($events, $template, $daytime, $currentMonth) {
		$dayrow = array();
		$dayrow['TEMPLATE_DAY'] = $template;

		$year = date('Y', $daytime);
		$month = date('m', $daytime);
		$day = date('d', $daytime);

		$dayrow['year'] = $year;
		$dayrow['month'] = $month;
		$dayrow['day'] = $day;

		#$day['events'] = array();
		#$day['events'][$year][$month][$day] = $events[$year][$month][$day];

		$dayrow['events'] = $events;

		$dayrow['day_time'] = $daytime;
		$dayrow['day_of_week'] = strftime('%u', $daytime);
		$dayrow['pi_flexform'] = $this->cObj->data['pi_flexform'];
		$dayrow['THIS_MONTH'] = $currentMonth;
		$dayrow['TODAY'] = mktime(0,0,0,date('m'),date('d'),date('Y'));
		$dayrow['event_count'] = count($events[$year][$month][$day]);

		$this->setFlexValues($dayrow);

		return $dayrow;
	}

	function displayDayFirst() {
		$template = $this->loadTemplate();

		if (isset($this->piVars['f3']))
			$day = $this->piVars['f3'];
		else
			$day = date('d');

		if (isset($this->piVars['f2']))
			$month = $this->piVars['f2'];
		else
			$month = date('m');

		if (isset($this->piVars['f1']))
			$year = $this->piVars['f1'];
		else
			$year = date('Y');


		$daytime = mktime(0,0,0,$month,$day,$year);

		$date_off = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'date_offset');
		if ($date_off != "") {
			$daytime = strtotime($date_off, $daytime);
			$year = date('Y', $daytime);
			$month = date('m', $daytime);
			$day = date('d', $daytime);
		}
		$endtime = strtotime("+1 days", $daytime);

		$eventmatrix = $this->getEventsInRange($year, $month, $day, date('Y', $endtime), date('m', $endtime), date('d', $endtime));

		$dayobj = t3lib_div::makeInstance('tslib_cObj');   // Create new tslib_cObj for our use
		$day = $this->makeDayRow($eventmatrix, $template, $daytime, $month);
		$dayobj->start($day);

		$lConf = $this->conf['displayDay.'];
		return $dayobj->cObjGetSingle($lConf['day'], $lConf['day.']);
	}

	function displayDay($content, $conf)	{
		$lConf = $conf;

		$data = $this->cObj->data;
		$year = $data['year'];
		$month = $data['month'];
		$day = $data['day'];
		$lConf = $conf;
		$eventmatrix = $data['events'];
		if ($eventmatrix == null) {
			$eventmatrix = array();
		}

		$starttime = mktime(0,0,0,$month,$day,$year);
		$endtime = strtotime("+1 days", $starttime);

                $interval = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'interval', 's_day');
		// default to 30 minutes
		if ($interval == 0)
			$interval = 1800;
			
		$todayptr = 0;
		$todaysevents = $eventmatrix[$year][$month][$day];
		$today_num = count($todaysevents);

		if ($today_num > 0)
			$has_events = true;
		else
			$has_events = false;

		$hourTableEvents = array();	// Events that need to be displayed hourly

		$today_time = mktime(0, 0, 0, $month, $day, $year);
		$tomorrow_time = strtotime("+1 days", $today_time);

		$theEvents = "";

		if (!is_array($todaysevents))
			$todaysevents = array();

		$eventTemplate = $this->cObj->getSubpart($data['TEMPLATE_DAY'], "###EVENTS###");

		// XXX make function of this class, typo3 coding guidelines
		usort($todaysevents, "sort_events_by_starttime");

		foreach($todaysevents as $row) {
			$row['EVENT_DURATION']	= floor(($row['end_time'] - $row['start_time']) / $interval);
			$row['THIS_DAY']	= $today_time;

			if ($row['start_date'] < $today_time) {
				$row['INTERVAL_START'] = $today_time;
				$row['EVENT_DURATION'] = floor($row['end_time'] / $interval);
			} else
				$row['INTERVAL_START'] = $row['start_date'] + floor($row['start_time'] / $interval) * $interval;

			if ($row['end_date'] + $row['end_time'] > $tomorrow_time) {
				$row['INTERVAL_END'] = $tomorrow_time;
				$row['EVENT_DURATION'] = floor(($tomorrow_time - $row['INTERVAL_START']) / $interval);
			}

			$addevent = $this->displayEvent($row, $lConf, $eventTemplate);

			$theEvents .= $addevent;
			continue;
		}


		return $theEvents;
	}

	function getEventsInRange($fromYear, $fromMonth, $fromDay, $toYear, $toMonth, $toDay) {
		$begin = mktime(0,0,0, $fromMonth, $fromDay, $fromYear);
		$end = mktime(0, 0, 0, $toMonth, $toDay, $toYear);

		$theMatrix = array();

		// first add all the recurring events
		$where = "(
				(
					rec_end_date = 0
				OR
					(
						rec_end_date >= $begin
					AND
						start_date < $end
					)
				)
			AND eventtype < 5 AND eventtype > 0)";
		// we must not filter for categories in the recurring events here, since the category might be overwritten by an exception below
		$query = $this->cObj->getQuery($this->dbTable, $this->getSelectConf($where));
		$res = mysql(TYPO3_db, $query);
		while ($row = mysql_fetch_assoc($res)) {
			// for every event, we need to calc the recurring times
			$startdate = $row['start_date'];
			$enddate = $row['end_date'];

			$orig_year = date('Y', $startdate);
			$orig_month = date('m', $startdate);
			$orig_day = date('d', $startdate);

			// fetch any exceptions to this event
			$where = "(eventtype = 5 AND exception_mm=".$row['uid']." AND start_date < $end)";
			$query = $this->cObj->getQuery($this->dbTable, $this->getSelectConf($where));
			$nres = mysql(TYPO3_db, $query);
			$ex = array();
			while ($arow = mysql_fetch_assoc($nres))
				$ex[] = $arow;
			mysql_free_result($nres);

			// calculdate duration of this day
			if ($enddate == 0 || $enddate == $startdate)
				$duration = 0;
			else
				// summertime fix
				$duration = floor(($enddate - $startdate) / (24 * 60 * 60));
			$rec_end_date = $row['rec_end_date'];
			$i = $startdate;
			$n = 0;
			while ($i < $end) {
				if ($row['rec_end_times'] > 0 && $n >= $row['rec_end_times'])
					break;

				if ($row['rec_end_date'] > 0 && $i > $row['rec_end_date'])
					break;


				// add the event at this day
				$year = date('Y', $i);
				$month = date('m', $i);
				$day = date('d', $i);
				// we need to adjust the start_date of this row
				$row['start_date'] = mktime(0,0,0,$month,$day,$year);
				if ($enddate != 0) {
					$row['end_date'] = $row['start_date'] + ($enddate - $startdate);
				}

				// get all exceptions and compare to this date
				$overwrite = null;
				foreach($ex as $e) {
					// XXX we should probably better check a RANGE (today - tomorrow) for the event's start-date due to timezone problems.
					if ($e['start_date'] == $row['start_date']) {
						$overwrite = $e;
					}
				}

				// unfortunately, we must re-calc the duratio (i.e. how many days to add)
				if ($overwrite == null)
					$add_duration = $duration;
				else {
					// calculdate duration of this day
					if ($overwrite['end_date'] == 0 || $overwrite['end_date'] == $overwrite['start_date'])
						$add_duration = 0;
					else
						// summertime fix
						$add_duration = floor(($overwrite['end_date'] - $overwrite['start_date']) / (24 * 60 * 60));
				}

				// add this to all the days how long it is taking
				$added = false;
				for ($j = 0; $j <= $add_duration; $j++) {
					$year = date('Y', strtotime("+$j days", $i));
					$month = date('m', strtotime("+$j days", $i));
					$day = date('d', strtotime("+$j days", $i));
					if ($overwrite == null) {
						if (!in_array($row['category'], $this->getCurrentCategories()))
							break;
						$theMatrix[$year][$month][$day][] = $row;
						$added = true;
					} else {
						if ($overwrite['exception_skip'] == 1)
							break;
						if (!in_array($overwrite['category'], $this->getCurrentCategories()))
							break;
						$theMatrix[$year][$month][$day][] = $overwrite;
						$added = true;
					}
				}
				if ($added)
					$n++;

				$weekdayarray = array("monday", "tuesday", "wednesday", "thursday", "friday", "saturday", "sunday");

				// now calc the next event
				switch($row['eventtype']) {
					case 1:	// daily
						// workdays, oder blabla XXX
						if ($row['repeat_days'] > 0)
							$diff = $row['repeat_days'];
						$i = strtotime("+$diff days", $i);
					break;
					case 2:	// weekly
						if ($row['repeat_weeks'] > 0)
							$diff = $row['repeat_weeks'];
						else
							$diff = 1;

						// is there a "on <day>" set, and if so, which is the last used day in the week?
						$ondays = 0;
						$daycount = 0;
						$firstday = 0;
						foreach($weekdayarray as $weekday) {
							$daycount++;
							if ($row["repeat_week_$weekday"] > 0) {
								$ondays = $daycount;
								if ($firstday == 0)
									$firstday = $daycount;
							}
						}

						if ($ondays == 0) {
							// none set, so just add $diff weeks and continue
							$i = strtotime("+$diff weeks", $i);
							break;
						}

						$weekday = strftime('%u', $i);
						// first we need to look if we are already at the last used day of the week, if so, we need to skip X weeks
						if ($weekday == $ondays) {
							// ok, this is the case.  so we need to skip to the next weeks
							$newi = strtotime("$diff ".$weekdayarray[$firstday - 1], $i);
							if ($newi == $i)
								$newi = strtotime("$diff weeks", $i);
							$i = $newi;
							$weekday = $firstday;
							continue;
						}

						// now we need to fetch the next day
						for ($iter = $weekday; $iter < 7; $iter++) {
							$weekdaystring = $weekdayarray[$iter];
							if ($row["repeat_week_$weekdaystring"] > 0) {
								$i = strtotime("this $weekdaystring", $i);
								break;
							}
						}
						break;
					case 3:	// monthly
						if ($row['repeat_months'] == 0)
							$diff = 1;
						else
							$diff = $row['repeat_months'];
						// we have a problem with 29, 30, 31 days, if the month has less days
						// fortunately $year and $month are set above. calculate the next month by the 15th of the month and
						// then get hte number of days of that month
						$month = date('m', $row['start_date']);
						$year = date('Y', $row['start_date']);
						$less = 0;
						$i = mktime(0,0,0, $month + $diff, $orig_day, $year);
						$safe_month = date('m', mktime(0,0,0, $month + $diff, 15, $year));
						while(date('m', $i) != $safe_month) {
							$less++;
							$i = mktime(0,0,0,$month + $diff, $orig_day - $less, $year);
						}
					break;
					case 4:	// yearly
						if ($row['repeat_years'] == 0)
							$diff = 1;
						else
							$diff = $row['repeat_years'];

						$day = date('d', $row['start_date']);
						$month = date('m', $row['start_date']);
						$year = date('Y', $row['start_date']);

						$i = mktime(0,0,0, $month, $day, $year + $diff);
					break;
				}
			}
		}
		mysql_free_result($res);

		$where = "(
				(start_date + start_time >= $begin AND start_date + start_time < $end)
			OR
				(start_date + start_time <= $begin AND end_date + end_time >= $begin)
			) AND eventtype = 0 ";

		//filter for category
		$where = '(' . $where . ' AND category IN (' . join(',', $this->getCurrentCategories()) . '))';
		$query = $this->cObj->getQuery($this->dbTable, $this->getSelectConf($where));
		$res = mysql(TYPO3_db, $query);
		while ($row = mysql_fetch_assoc($res)) {
			// for every event, we take a look when it begins and when it stops
			$startdate = $row['start_date'];
			$enddate = $row['end_date'];
			if ($enddate == 0)
				$enddate = $startdate;
			for ($i = $startdate; $i <= $enddate; $i = strtotime("+1 day", $i)) {
				$year = date('Y', $i);
				$month = date('m', $i);
				$day = date('d', $i);
				$theMatrix[$year][$month][$day][$row['uid']] = $row;
			}
		}
		mysql_free_result($res);

		return $theMatrix;
	}


	function week2time($year, $week) {
		$weekoff = $week - 1;
		// Jan 4 is always in week 1
		if ($weekoff == 52)
		//	$weektime = strtotime("-1 week", mktime(0, 0, 0, 1, 4, $year));
			$weektime = strtotime("-1 week", mktime(0, 0, 0, 1, 4, $year));
		else
			$weektime = strtotime("+$weekoff weeks", mktime(0, 0, 0, 1, 4, $year));

		$dayoff = $this->getDayOfTheWeek($weektime) - 1;
		$weektime = strtotime("-$dayoff days", $weektime);
	
		return $weektime;
	}
	function week2time_start($year, $week) {
		$weekoff = $week - 1;
		$weektime = strtotime("+$weekoff weeks", mktime(0, 0, 0, 1, 4, $year));

		$dayoff = $this->getDayOfTheWeek($weektime) - 1;
		$weektime = strtotime("-$dayoff days", $weektime);
	
		return $weektime;
	}
	function week2time_end($year, $week) {
		$weekoff = $week - 1;
		$weektime = strtotime("+$weekoff weeks", mktime(0, 0, 0, 1, 4, $year));

		$dayoff = 7 - $this->getDayOfTheWeek($weektime);
		$weektime = strtotime("+$dayoff days", $weektime);
	
		return $weektime;
	}


	function displayWeekFirst() {
		$template = $this->loadTemplate();

		if (isset($this->piVars['f2']))
			$week = $this->piVars['f2'];
		else
			$week = strftime('%V');

		if (isset($this->piVars['f1']))
			$year = $this->piVars['f1'];
		else
			$year = date('Y');

		$weektime = $this->week2time_start($year, $week);

		// maybe we need to adjust
                $date_off = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'date_offset');
		if ($date_off != "") {
			$weektime = strtotime($date_off, $weektime);
			if ($weektime == -1)
				return "invalid date offset string";
			$week = strftime('%V', $weektime);
			$year = date('Y', $weektime);
		}

		$month = date("m", $weektime);

		$eventmatrix = $this->getEventsInRange($year, $month - 1, 15, $year, $month + 1, 15);

		$weekobj = t3lib_div::makeInstance('tslib_cObj');   // Create new tslib_cObj for our use
		$weekrow = $this->makeWeekRow($eventmatrix, $template, $weektime, $month);
		$weekobj->start($weekrow);

		$lConf = $this->conf['displayWeek.'];
		return $weekobj->cObjGetSingle($lConf['week'], $lConf['week.']);
	}

	function makeWeekRow($events, $template, $weektime, $currentMonth) {
		$week = array();
		$week['events'] = $events;
		$week['TEMPLATE_WEEK'] = $template;
		$week['year'] = date('Y', $weektime);
		$week['week'] = strftime("%V", $weektime);
		$week['week_time'] = $weektime;
		$week['pi_flexform'] = $this->cObj->data['pi_flexform'];
		$week['THIS_MONTH'] = $currentMonth;
		$this->setFlexValues($week);

		return $week;
	}



	/**
	 * display the Week-View.  
	 */
	function displayWeek($content, $conf) {
		$lConf = $conf;

		$data = $this->cObj->data;
		$dayTemplate = $this->cObj->getSubpart($data['TEMPLATE_WEEK'], "###DAYS###");
		$year = $data['year'];
		$week = $data['week'];
		$eventmatrix = $data['events'];
		if ($eventmatrix == null) {
			$eventmatrix = array();
		}

		$weektime = $data['week_time'];
		$month = date("m", $weektime);
		$beginday = date("d", $weektime);

		$weektable = "";
		for ($i = 0; $i < 7; $i++) { // First, fetch the events of this day
			$daytime = strtotime("+$i days", $weektime);
			# $theDay = $this->displayDay($content, $lConf, $eventmatrix, $dayTemplate, date('Y', $daytime), date('m', $daytime), date('d', $daytime));

			$dayobj = t3lib_div::makeInstance('tslib_cObj');   // Create new tslib_cObj for our use
			$day = $this->makeDayRow($eventmatrix, $dayTemplate, $daytime, $data['THIS_MONTH']);
			$dayobj->start($day);

			$weektable .= $dayobj->cObjGetSingle($lConf['day'], $lConf['day.']);
		}

		return $weektable;
	}

	function displayMonthFirst() {
		$template = $this->loadTemplate();

		if (isset($this->piVars['f2']))
			$month = $this->piVars['f2'];
		else
			$month = date('m');

		if (isset($this->piVars['f1']))
			$year = $this->piVars['f1'];
		else
			$year = date('Y');

		$monthBegin = mktime(0, 0, 0, $month, 1, $year);

		// maybe we need to adjust
                $date_off = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'date_offset');
		// XXX we need to make sure this is only done if we are in the right viewmode
		if ($date_off != "") {
			$monthBegin = strtotime($date_off, $monthBegin);
			if ($monthBegin == -1)
				return "invalid date offset string";
			$month = date('m', $monthBegin);
			$year = date('Y', $monthBegin);
		}

		if ($eventmatrix == null) {
			$eventmatrix = $this->getEventsInRange($year, $month - 1, 1, $year, $month + 2, $day);
		}

		$monthobj = t3lib_div::makeInstance('tslib_cObj');   // Create new tslib_cObj for our use
		$monthrow = $this->makeMonthRow($eventmatrix, $template, $monthBegin);
		$monthobj->start($monthrow);

		$lConf = $this->conf['displayMonth.'];
		return $monthobj->cObjGetSingle($lConf['month'], $lConf['month.']);
	}

	function makeMonthRow($events, $template, $monthtime) {
		$month = array();
		$month['events'] = $events;
		$month['TEMPLATE_MONTH'] = $template;
		$month['year'] = date('Y', $monthtime);
		$month['month'] = date('m', $monthtime);
		$month['month_time'] = $monthtime;
		$month['pi_flexform'] = $this->cObj->data['pi_flexform'];

		$this->setFlexValues($month);

		return $month;
	}

	function displayMonth($content, $conf) {
		$lConf = $conf;

		$data = $this->cObj->data;
		$year = $data['year'];
		$month = $data['month'];
		$eventmatrix = $data['events'];
		if ($eventmatrix == null) {
			$eventmatrix = array();
		}
		$monthBegin = mktime(0, 0, 0, $month, 1, $year);
		$nextMonth = strtotime("+1 months", $monthBegin);

		if ($this->getDayOfTheWeek($monthBegin) == 1) {
			$firstDay = $monthBegin;
		} else {
			$daysoff = $this->getDayOfTheWeek($monthBegin) - 1;
			$firstDay = strtotime("-$daysoff days", $monthBegin);
		}

		/* Create the Matrix - week-wise */
		$weekTemplate = $this->cObj->getSubpart($data['TEMPLATE_MONTH'], "###WEEKS###");

		$i = 0;
		$calstr = "";
		while (1) {
			$weektime = strtotime("+$i weeks", $firstDay);
			if ($weektime >= $nextMonth)
				break;

			$weekobj = t3lib_div::makeInstance('tslib_cObj');   // Create new tslib_cObj for our use
			$weekrow = $this->makeWeekRow($eventmatrix, $weekTemplate, $weektime, $month);
			$weekobj->start($weekrow);

			$theWeek = $weekobj->cObjGetSingle($lConf['week'], $lConf['week.']);
			/*

			$week = date('W', $weektime);
		    	$week = $this->displayWeek($lConf, $eventmatrix, $calMatrixTemplate, strftime("%G", $weektime), $week, $month);
			$calstr .= $this->cObj->stdWrap($week, $lConf['weekWrap.']);

			*/
			$calstr .= $theWeek;
			$i++;
		}

		return $calstr;
	}

	function displayUpcomingFirst() {
		$template = $this->loadTemplate();
		$eventTemplate = $this->cObj->getSubpart($template, "###EVENTS###");

		if (isset($this->piVars['f3']))
			$day = $this->piVars['f3'];
		else
			$day = date('d');

		if (isset($this->piVars['f2']))
			$month = $this->piVars['f2'];
		else
			$month = date('m');

		if (isset($this->piVars['f1']))
			$year = $this->piVars['f1'];
		else
			$year = date('Y');

               	$howmany = intval($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'how_many', 's_upcoming'));
		$daytime = mktime(0,0,0,$month,$day,$year);
		$date_off = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'date_offset');
		if ($date_off != "") {
			$daytime = strtotime($date_off, $daytime);
			$year = date('Y', $daytime);
			$month = date('m', $daytime);
			$day = date('d', $daytime);
		}

		$lConf = $this->conf['displayUpcoming.'];

		$n = 0;
		$daevents = array();
		$i = 1;
		while ($n < $howmany) {
			$eventmatrix = $this->getEventsInRange($year, $month, $day + 10 * ($i - 1), $year, $month, $day + 10 * $i );
			for ($j = 0; $j < 10; $j++) {
				$daytime = mktime(0,0,0, $month, $day + 10 * ($i - 1) + $j, $year);
				$e = $eventmatrix[date('Y', $daytime)][date('m', $daytime)][date('d', $daytime)];
				if (is_array($e)) {
					$daevents = array_merge($daevents, $e);
				}
			}

			// filter double entries
			foreach ($daevents AS $key => $arr)
   				$daevents[$key] = serialize($arr);
			$daevents = array_unique($daevents);
			foreach ($daevents AS $key => $arr)
   				$daevents[$key] = unserialize($arr);

			$n = count($daevents);
			$i++;
		}

		for ($i = 0; $i < $howmany; $i++) {
			$row = $daevents[$i];
			$addevent = $this->displayEvent($row, $lConf, $eventTemplate);
			$theEvents .= $addevent;
			continue;
		}

		$subpartArray = array(
			'EVENTS'	=>	$theEvents,
		);
 		$content = $this->cObj->substituteMarkerArrayCached($template, array(), $subpartArray, array());

		return $content;
	}

	// Load the template for the given instance
	function loadTemplate() {
               	$defaulttemplate = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'template_use_default', 's_template');
		if ($defaulttemplate != "") {
			$theFile = "EXT:calendar/templates/" . $defaulttemplate;
		} else {
			// we shall use the uploaed template.  Go for it
			$theFile = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'template_file', 's_template');
		}

		$templateCode = $this->cObj->fileResource($theFile);
		if ($templateCode == "") {
			return '<h3>' . $this->extKey . ': no template file found:'.$this -> conf["templateFile"] . '</h3>';
		}

		return $templateCode;
	}


	function getSelectConf($where) {
		//get events
		$selectConf = Array();
		$selectConf["pidInList"] = $this->pid_list;
		$selectConf["where"] = $where;
		$selectConf["orderBy"] = "start_date, start_time";
		return $selectConf;
	}

	function getMonthPage() {
                return $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'month_page');
	}
	function getDayPage() {
                return $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'day_page');
	}
	function getWeekPage() {
                return $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'week_page');
	}


	/**
	 * Make the selectorbox with categories.
	*/
	function makeCategorySelect($content, $conf) {
		$this->initdefaults($content, $conf);

		$opt = array();

		$selCat = $this->piVars['category'];

		$value = htmlentities($this->pi_linkTP_keepPIvars_url(array("category" => "")));

		/* Suck in label for "allCategories" from typoscript */
		if ($this->conf["allCategoriesMarker"])
			$opt[] = '<option value="'.$value.'">'.$this -> conf["allCategoriesMarker"].'</option>';
		else
			// if unset, use the one from locallang
			$opt[] = '<option value="'.$value.'">'.$this -> pi_getLL('allCategoriesMarker').'</option>';

		foreach ($this->categories as $cat) {
			if ($cat['uid'] == 0)
				continue;
			$opt[] = '<option value="'.
				htmlentities($this->pi_linkTP_keepPIvars_url(array("category" => $cat['uid']), $this->allowCaching))
				.'"'.
				($selCat[0] == $cat['uid'] ? " SELECTED" : "")
				.'>'.
				htmlentities($cat['title'])
				.'</option>';
		}
		return '<select onChange="document.location='."'".$GLOBALS['TSFE']->baseUrl."'".' + this.options[this.selectedIndex].value;">'.implode("", $opt).'</select>';
	}
	/* -------------- small helper functions ----------------- */

	function setCurrentCategory($theValue) {
		$this->piVars["category"] = intval($theValue);
	}
	function getCurrentCategories() {
		if (isset($this->piVars["category"])) {
			return array(0 => intval($this->piVars["category"]));
		} else {
			return array_keys($this->categories);
		}
	}

	function getDayOfTheWeek($theTime) {
		$day =  date("w", $theTime);
		return ($day == 0 ? 7 : $day);
	}

	function getCurrentView() {
                return $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'viewmode');
	}

	/**
	 * Sets the pid_list internal var
	 */
	function setPidlist($pid_list) {
		$this->pid_list = $pid_list;
	}
	function getPidlist() {
		return $this->pid_list;
	}

	/**
	 * Extends the internal pid_list by the levels given by $recursive
	 */
	// Stolen from tt_news ;-)
	function generatePidlistRecursive($pid_list, $recursive)      {
		if ($pid_list == "")
			$pid_list = $GLOBALS["TSFE"]->id;
		if ($recursive) {               // get pid-list if recursivity is enabled
			$pid_list_arr = explode(",", $pid_list);
			$pid_list = "";
			while(list(, $val) = each($pid_list_arr))  {
				$pid_list .= $val . "," . $this->cObj->getTreeList($val, intval($recursive));
			}
			$pid_list = ereg_replace(",$", "", $pid_list);
		}
		return $pid_list;
	}

}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/calendar/pi1/class.tx_calendar_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/calendar/pi1/class.tx_calendar_pi1.php"]);
}

?>
